#include <dbgmem.h>
#include <zobject.h>
#include "zsort.h"


struct bucket {
  ZObject *first;
  ZObject *last;
};

static struct bucket buckets[256];

ZObject *ZSortList(ZObject *list)
{
  int round;
  int i;
  ZObject *cur,*next;
  int bucket;

  ZObject **last;

  for (i=0;i<256;i++) {
    buckets[i].first=0;
  }

  for (round=0;round<4;round++) {
    cur=list;
    while (cur) {
      next=cur->next;
      bucket=cur->ZValue&0xff;
      cur->ZValue>>=8;
      if (buckets[bucket].first==0) {
	buckets[bucket].first=cur;
        buckets[bucket].last=cur;
      } else {
        buckets[bucket].last->next=cur;
        buckets[bucket].last=cur;
      }
      cur->next=0;
      cur=next;
    }

    last=&list;
    for (i=255;i>=0;i--) {
      if (buckets[i].first) {
        *last=buckets[i].first;
	last=&(buckets[i].last->next);
	buckets[i].first=0;	
      }
    }
    *last=0;
  }

  return list;
}
